<?php

namespace App\Jobs;

use App\Setting;
use Carbon\Carbon;

class WhatsappUnsoldCommodityScanner extends Job
{
    public $status;
    public $start_time;
    public $message;

    /**
     * Create a new job instance.
     *
     * @return void
     */
    public function __construct()
    {
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        $logger = app('job_log');

        try {

            $logger->info('Scanning Unsold Commodity Notifications Settings');
        
            $settings = Setting::on('mysql7')->where('group', 'unsold_commodity_notifications')->get();
            $status = $settings->where('key', 'status')->first()->value;
            $start_time = $settings->where('key', 'start_time')->first()->value;

            if ($status === '0') {
                $logger->info('Unsold commodity notifications are turned off, no notification will be sent');
                return false;
            }

            dispatch((new WhatsappUnsoldCommodityNotification($this->message))->delay(Carbon::parse($start_time)));

        } catch (\Exception $e) {
            $logger->error($e);
            throw $e;
        }

    }
}
